clear all;  clc;
NT=4; %  number of antennas at the transmiter
NR=200; %  number of antennas at the receiver ( numbers >= NT)
% clear all, clc;
RN=sum(100*clock);
RS=RandStream('mt19937ar','seed',RN);
RandStream.setGlobalStream(RS);
 rate=1/2;   
Sgh = 0.91;
%  -------------------------------------------------- data generation
 k=2048;                  %interleaver umts size         
 Str_L=20;               %  
 N=k*Str_L;               %---No. of transmitted symbols
 data=randi([0 1],1,N);
 %------------------------------------------------
     s1 = RandStream('mt19937ar', 'Seed', 12345);

    M=2;% constellation size of the modulation

%----------------------------channel calculations--------
tic
  SNRdB=[-18:0.5:-9];% -7.5:0.5:-7];
%  SNRdB=[-10:-7 -6.5:0.5:-6 -5.9:0.1:-4.5];
% SNRdB=[-18:0.5:-16 -15.9:0.1:-15];% -14:-11 -10.9:0.1:-10.5];
SNR_L=10.^(SNRdB/10);
fft_l=1024;
Gp=fix(0.25*fft_l); %guard interval
[h,H]=chan1(NR,NT,fft_l);
Hre=real(H);
Him=imag(H);
%---------------------------------------------------------

ml=log2(M);        % ----QAM Constelations------------------
 if (M==4)
%         C=[-1+1i -1-1i 1+1i 1-1i];
           C=[-1-1i -1+1i 1-1i 1+1i];        

 elseif (M==2)
     C=[1,-1];
    elseif (M==16)
%         C=[-3-3j -3-1j -3+3j -3+1j -1-3j -1-1j -1+3j -1+1j 3-3j 3-1j 3+3j 3+1j 1-3j 1-1j 1+3j 1+1j];   %      Gray
        C = [-3+3j -3+1j -3-3j -3-1j -1+3j -1+1j -1-3j -1-1j 3+3j 3+1j 3-3j 3-1j 1+3j 1+1j 1-3j 1-1j];

 end
%%%%%%   Noise calculations  %%%%%%%%%%
Es=mean(abs(C).^2);
Eb=Es/log2(M);
sigma=sqrt(Eb*0.5*NT*10.^(-SNRdB/10)/rate);
Ls=length(SNRdB);


 %  -----------------------------------------------------Encoder parameters
%      g=[1 0 0 1 1;1 1 1 0 1];%(23,35)
%     g=[0 0 1 0 1 1 0 1 1;0 0 1 1 1 1 0 0 1];
%     g=[0 1 0 1 0 0 1 1 1;0 1 1 1 1 1 0 0 1];%(247,371)
    g=[1 0 1 1 1 0 0 0 1;1 1 1 1 0 1 0 1 1];
%     g=[0 0 1 0 0 1 1 0 1 0 0 1;0 0 1 1 1 1 1 0 1 0 1 1];% (1151,1753)


codeword_1 = ConvEncode(data, g );
% Converting the returned data into one stream of binary bits
codeword1 = randintrlv(codeword_1, s1);
reset(s1)
Bin_coded_data=reshape(codeword1.',1, size(codeword1,1)* size(codeword1,2));
% binarry to decimal
 if (M==4)
     for indx=1:2:size(Bin_coded_data,2)
        coded_data(1+((indx-1)/2))=Bin_coded_data(indx)*2+Bin_coded_data(indx+1);
     end
 elseif (M==2)
     coded_data = Bin_coded_data;
 elseif (M==16)
     for indx=1:4:size(Bin_coded_data,2)
         coded_data(1+((indx-1)/4))=Bin_coded_data(indx)*8+Bin_coded_data(indx+1)*4+Bin_coded_data(indx+2)*2+Bin_coded_data(indx+3);
     end
 end

%  ----adding zero padding to the input data to compensate the lack in the length

if (rem(size(coded_data,2),fft_l*NT)~=0)
    Missing_s=fft_l*NT-rem(size(coded_data,2),fft_l*NT);
    extra_data=zeros(1,Missing_s);
    coded_data1=[coded_data extra_data];
else 
    coded_data1=coded_data;
end
%-----------------------Splitting the coded data into L streams  ------------------
L=size(coded_data1,2)/fft_l;

x_in=reshape(coded_data1,fft_l,L)';
for k2=1:NT
    xin(k2,:,:)=x_in(1+(k2-1)*L/NT:k2*L/NT,:);
end
ber=zeros(1,Ls);





for SNR=1:Ls            %  --------   SNR loop --------------- %
    total_errors=0;
    total_errors1=0;
    zf=[];
    for L2=1:L/NT   %   for two transmitter
        
        for k2=1:NT
            x(k2,:)=xin(k2,L2,:);%
        end
        %   ----------  QAM_ Modulation----------
        for k2=1:NT
            QAM_m(k2,:)=C(x(k2,:)+1);
        end
        %----------IFF+GP or CP   for tx1 -------------------------
        for k2=1:NT
            ofdm(k2,:)=sqrt(fft_l)*ifft(QAM_m(k2,:)); %subcarrier generation by IFFT
            guard_symbol(k2,:)=ofdm(k2,end-Gp+1:end); %calculation of guard symbol
            TX(k2,:)=[guard_symbol(k2,:) ofdm(k2,:)]; %adding guard symbol
        end
        
        % ------------- applying the effect of the channel ----------%
        s=zeros(NR,fft_l+Gp);
        for k1=1:NR
            for k2=1:NT
                ha(:,:)=h(k1,:,:);
                %                     R1(k1,:)=filter(mimochan.num(k1).chan,TX(1,:);
                [R(k2,:),zf]=filter(ha(k2,:),1,TX(k2,:),zf);
                
                s(k1,:)=s(k1,:)+R(k2,:);
                
            end
            s(k1,:)=(s(k1,:)+sigma(SNR)*(randn(1,fft_l+Gp)+1j*randn(1,fft_l+Gp)));
        end
        
        
        %%%%------------- RX--------------
        
        %  ----------------- FFT operations ------------------------------
        
        for k1=1:NR
            r_data(k1,:)=s(k1,Gp+1:end); %removed guard symbol
            info_2N(k1,:)=1/sqrt(fft_l)*fft(r_data(k1,:)); %baseband recieved OFDM symbol
        end
        
        
       
        
%         %----------------------------- MMSE estimation---------
         for ys=1:fft_l
             MMS(:,:,ys)=(Es*H(:,:,ys)'*H(:,:,ys)+sigma(SNR)^2*eye(NT))\(Es*H(:,:,ys))';
%                MMS(:,:,ys)=(H(:,:,ys)'*H(:,:,ys))\H(:,:,ys)';
               Xhat1 (:,ys)=(MMS(:,:,ys)*info_2N(:,ys));
            
         end
        %  ------------------  CML  ---------------------------------%
        
            for k1=1:NT
                
%                 LLr1 =  -LLR_calc17(Xhat1(k1,:),M,sigma(SNR),Sgh,NR);
%                 LLr1 =  -LLR_calc1_16(Xhat1(k1,:),M,sigma(SNR),Sgh,NR);
%                 LLr1 =  0.0842*real(Xhat1(k1,:).^3)-4.27*real(Xhat1(k1,:)); % NR200_NT10
          
               LLr1 =  Gaussian_pdf(Xhat1(k1,:),M,sigma(SNR));

                LLR1(:,k1)=LLr1;
            end

        LLR2(:,L2,:)=LLR1;%

        %----------------------------------------------------------------------------
%     pause(0.1)
%     L2
    end     %   L2 loop
    LLR3=reshape(LLR2,1,L*ml*fft_l);
    LLR3=LLR3(1:size(codeword1,2)*size(codeword1,1));
    LLR_3 = randdeintrlv(LLR3, s1);
    reset(s1)
    LLR=reshape(LLR_3,size(codeword1,2),size(codeword1,1))';

     % ----------------------------------Decoding -----------------
%      [detected_data, errors, output_decoder_c, input_upper_u] = TurboDecode( LLR , data, turbo_iterations, decoder_type, code_interleaver, pun_pattern, tail_pattern, g, flag_1, g, flag_2 );
   data_out = ViterbiDecode( LLR, g) ;
   errors(SNR) = biterr(data,data_out);
     ber(SNR)=errors(SNR)/(N)
        SNRdB(SNR)
        toc
       if ber(SNR)<1e-6
           break
    
       end
    
    
end     % SNR loop

figure(1);
ber
%  hold on
% semilogy(SNRdB,ber(:,1),'k',SNRdB,ber(:,2),'r',SNRdB,ber(:,turbo_iterations),'b'),grid
semilogy(SNRdB,ber,'b*-'),grid on
xlabel(' SNR(dB)')
ylabel('BER')
% title('performance of coded MIMO-OFDM under freq. selec. channel ');
hold on
% legend('1st iteration','2nd itteration ','10 iterations',3)





toc