function fact = fact_c1(n1,n2,n3,n4,x,F1,F2,n5,F3)

% This function will be used to calculate:
% (M+k-1)!  / ( (M-k-1)! k! 2^(M+k))
% using log steriling approximation
% n1 - is the numerator factorial (M+k-1)!.
% n2 - is (M-k-1)!.
% n3 - is k!.

% x  - is the log2(2^x) = x

%  ------------------------------------
n1_lg=n1*log2(n1/exp(1))+0.5*log2(2*pi*n1);
n4_lg=n4*log2(n4/exp(1))+0.5*log2(2*pi*n4);
n5_lg=n5*log2(n5/exp(1))+0.5*log2(2*pi*n5);

if n2==0
    n3_lg=n3*log2(n3/exp(1))+0.5*log2(2*pi*n3);

    fact=2.^(n1_lg+n4_lg+F1+F2-n3_lg-x-2*n5_lg-F3);
elseif n3==0
    n2_lg=n2*log2(n2/exp(1))+0.5*log2(2*pi*n2);

    fact=2.^(n1_lg+n4_lg+F1+F2-n2_lg-x-2*n5_lg-F3);
    
else
    
        n2_lg=n2*log2(n2/exp(1))+0.5*log2(2*pi*n2);

        n3_lg=n3*log2(n3/exp(1))+0.5*log2(2*pi*n3);

        fact=2.^(n1_lg+n4_lg+F1+F2-n2_lg-n3_lg-x-2*n5_lg-F3);

end