clear all
clc
Nt=10;
Nr=100;
sgh=1/sqrt(2);
SNR=-10:0;
snr=10.^(SNR./10);
C=2;
if C==2
    Eb = 1;
else
Eb = 2/3*(C-1)/log2(C);
end
sgw=sqrt(Eb*Nt*0.5./snr);

Pe = 0;
for k=1:Nr
    for m=0:Nr-k
        log_pe = (logfac(Nr+k-2) +  logfac(Nr+m-1) + Nr.*log(sgw./(2*sgh))) - ( 2*logfac(Nr-1) + logfac(k-1) + logfac(m) + (Nr+k-1)*log(2) + (Nr+m).* log (1+(sgw./(2*sgh))) );
        Pe = Pe + exp(log_pe);
        %        Pe = Pe + (factorial(M+k-2) * gamma(M+m) * (sgw./(2*sgh)).^M) ./ (  gamma(M)^2 * factorial(k-1) * 2^(M+k-1) *  factorial(m) * (1+(sgw./(2*sgh))).^(M+m));
    end
end
if (C == 2)||(C==4)
    Pb = Pe;
else
    Pe1 = 2*(1-1/sqrt(C))*Pe;
    Pb=(1-(1-Pe1).^2)./log2(C);
end

if Nr == 100
    semilogy(SNR,abs(Pb),'--d','Color','b','linewidth',2)
else
    semilogy(SNR,abs(Pb),'--o','Color','k','linewidth',2)
end
axis([min(SNR) max(SNR) 10^-6 1.2]);
xlabel('$SNR~(dB)$','Interpreter','Latex')
ylabel('$BER$','Interpreter','Latex')
grid on
hold on




