% clear all; close all; clc;
clear all ; clc;
NT=10; %  number of antennas at the transmiter
NR=100; %  number of antennas at the receiver ( numbers >= NT)
% clear all, clc;
tic
% RN=sum(100*clock);
% RS=RandStream('mt19937ar','seed',RN);
% RandStream.setGlobalStream(RS);
L=10;                   %   number of baseband streams for two transmitter (even number >2NT)
fft_l=1024;
Gp=fix(0.25*fft_l); %guard interval

%----------------------------channel calculations--------
[h,H]=Chan_2(NR,NT,fft_l);
% [h,H]=chan1(NR,NT,fft_l);


%---------------------------------------------------------

N=L*fft_l;         %---No. of transmitted symbols
SNRdB=[-10:0];
% SNRdB=[-30:5:0 0.5:0.5:8 10:5:20];
M=4;                     % qam size
ml=log2(M);        % ---- QAM Generation ------------------
if (M==4)
    C=[-1+1i -1-1i 1+1i 1-1i];
elseif (M==2)
    C=[-1;1];
elseif (M==16)
    %     C=[-3+3i -3+1i -3-1i -3-3i -1+3i -1+1i -1-1i -1-3i 1+3i 1+1i 1-1i 1-3i 3+3i 3+1i 3-1i 3-3i]; %          Binary
    C=[-3+3j -3+1j -3-3j -3-1j -1+3j -1+1j -1-3j -1-1j 3+3j 3+1j 3-3j 3-1j 1+3j 1+1j 1-3j 1-1j];   %         Gray
elseif M==64;
C=[-7 + 7j,-7 + 5j,-7 + 3j,-7 + 1j,-7 - 1j,-7 - 3j,-7- 5j,-7 - 7j,...
-5 + 7j,-5 + 5j,-5 + 3j,-5 + 1j,-5- 1j,-5 - 3j,-5 - 5j,-5 - 7j,...
-3 + 7j,-3 + 5j,-3 + 3j,-3 + 1j,-3 - 1j,-3 - 3j,-3 - 5j,-3 - 7j,...
-1 + 7j,-1 + 5j,-1 + 3j,-1 + 1j,-1 - 1j,-1 - 3j,-1 - 5j,-1 - 7j,...
1 + 7j,1 + 5j,1 + 3j,1 + 1j,1 - 1j,1 - 3j,1 - 5j,1 - 7j,3 + 7j,...
3 + 5j,3 + 3j,3 + 1j,3 - 1j,3 - 3j,3 - 5j,3 - 7j,5 + 7j,5 + 5j,...
5 + 3j,5 + 1j,5 - 1j,5 - 3j,5 - 5j,5 - 7j,7 + 7j,7 + 5j,7 + 3j,...
7+ 1j,7 - 1j,7 - 3j,7 - 5j,7 - 7j]; % 64 QAM Constellation Size

end
%%%%%%   Noise calculations  %%%%%%%%%%
Es=mean(abs(C).^2);
Eb=Es/log2(M);
sigma=sqrt(Eb*0.5*NT*10.^(-SNRdB/10));
Ls=length(SNRdB);
ber1=zeros(1,Ls);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
Sum_q1=zeros(Ls);
Sum_q=zeros(Ls);
%---------------------- Create M-QAM modulator
SNR_L=10.^(SNRdB/10);

for SNR=1:Ls            %  --------   SNR loop --------------- %
    total_errors=0;
    total_errors1=0;
    zf=[];zf_d=[];
    zf1=[];zf_d1=[];
%     [h,H]=chan1(NR,NT,fft_l);
    for L2=1:L/NT   %   for two transmitter
        
        DATA(L2,:)=randi([0 M-1],1,NT*fft_l);%
        %             data=DATA(L2,:);
        for k2=1:NT
            x(k2,:)=DATA(L2,1+(k2-1)*fft_l:k2*fft_l);%
        end
        %         QAM_m=modulate(MOD,x);
        for k2=1:NT
            QAM_m(k2,:)=C(x(k2,:)+1);
        end
        %----------IFF+GP or CP   for tx1 -------------------------
        for k2=1:NT
            ofdm(k2,:)=sqrt(fft_l)*ifft(QAM_m(k2,:)); %subcarrier generation by IFFT
            guard_symbol(k2,:)=ofdm(k2,end-Gp+1:end); %calculation of guard symbol
            TX(k2,:)=[guard_symbol(k2,:) ofdm(k2,:)]; %adding guard symbol
        end
        
        % ------------- applying the effect of the channel ----------%
        s=zeros(NR,fft_l+Gp);
        for k1=1:NR
            for k2=1:NT
                ha(:,:)=h(k1,:,:);
                %                     R1(k1,:)=filter(mimochan.num(k1).chan,TX(1,:);
                [R(k2,:),zf]=filter(ha(k2,:),1,TX(k2,:),zf);
                
                s(k1,:)=s(k1,:)+R(k2,:);
                
            end
            Noise(k1,:)=sigma(SNR)*(randn(1,fft_l+Gp)+1j*randn(1,fft_l+Gp));
            s(k1,:)=(s(k1,:)+Noise(k1,:));
        end
        
        
        %%%%------------- RX--------------
        
        %  ----------------- FFT operations ------------------------------
        
        for k1=1:NR
            r_data(k1,:)=s(k1,Gp+1:end); %removed guard symbol
            info_2N(k1,:)=1/sqrt(fft_l)*fft(r_data(k1,:)); %baseband recieved OFDM symbol
            
        end
        
        
 
        
        %----------------------------- MMSE estimation---------
        for ys=1:fft_l
%             MMS(:,:,ys)=(Es*H(:,:,ys)'*H(:,:,ys)+sigma(SNR)^2*eye(NT))\(Es*H(:,:,ys))'; % MMSE
%             MMS(:,:,ys)=(H(:,:,ys)'*H(:,:,ys))\(H(:,:,ys))'; %ZF
            MMS(:,:,ys)=H(:,:,ys)'/(H(:,:,ys)*H(:,:,ys)'+sigma(SNR)^2/Es*eye(NR)); %ZF
            Xhat2(:,ys)=MMS(:,:,ys)*info_2N(:,ys);
            
        end
        

        %-----------------------------------------------------
        for k2=1:NT
            for ii=1:fft_l
                [~,minIndex2] = min(abs(Xhat2(k2,ii) - C));
                data_out2(k2,ii)=minIndex2 - 1;
            end
        end
        xr2(L2,:)=reshape(data_out2',1,NT*fft_l);
        %             for k2=1:NT
        %             xr(L2,1+(k2-1)*fft_l:k2*fft_l)=data_out(k2,:);
        %             end
        
        %******************** Bit Error Rate (BER) ****************************
     
        errork1=0;
        for k2=1:NT
            [new_errors1,~] = biterr(data_out2(k2,:),x(k2,:));
            %                [new_errors,~] = biterr(xr(L2,:),DATA(L2,:));
            errork1=errork1+new_errors1;
        end
        total_errors1=total_errors1+errork1;
        
        
        
    end   %  ---------------L loop
    ber1(SNR)=total_errors1/(L*ml*fft_l);
    
    disp(sprintf('Eb/No = %f\t Bit error rate = %e\n ',SNRdB(SNR),ber1(SNR)))
    %         disp(sprintf('Eb/No = %f\t Bit error rate = %e\t Bit error rate = %e\n ',SNR,ber1(SNR),ber(SNR)))
    if ber1(SNR)<1e-6
        break
        
    end
    
  
end%           ---------SNR LOOP_________
%
figure(1);
% ber;
% semilogy(SNRdB,ber,'go-',SNRdB,ber1,'bs-'),grid
 semilogy(SNRdB,ber1,'-ob','LineWidth',2,'MarkerEdgeColor','k','MarkerFaceColor','r','MarkerSize',6);
grid on
xlabel(' $SNR~(dB)$')
ylabel('$BER$')
% title('MIMO OFDM under frequency selective fading channel ');
hold on
% legend('simulation result with MMSE')
toc
